\documentclass[a4paper]{article}
\usepackage[left=2.2cm,right=2.2cm,top=2.5cm,bottom=2.5cm]{geometry} % page settings
\usepackage{amsmath}
\usepackage{amssymb}
%\usepackage{amsthm}
%\usepackage{etoolbox}
\usepackage[english]{babel}
\usepackage[utf8]{inputenc}
%\usepackage{framed}
\usepackage{fancyhdr}
%\usepackage{tikz}
\usepackage{graphicx}
\usepackage{subcaption}
\usepackage{hyperref}

\setlength{\parskip}{\medskipamount}
\setlength{\parindent}{0pt}

\pagestyle{fancy}
\lhead{
    \begin{tabular}{ll}
      Lab Course Deep Learning \\
      Winter term 2017/18
  \end{tabular}
}
\chead{}
\rhead{
  \begin{tabular}{ll}
    Fabian Glöckle \\
    08/01/2018
  \end{tabular}
}
\lfoot{}
\cfoot{}
\rfoot{} 


\begin{document}

\title{Deep Learning Lab Course Report 6}
\author{Fabian Glöckle}
\date{\today}
% \maketitle

\subsection*{Hyperparameter optimization: SMAC and Hyperband} 

In this exercise , we used implementations of SMAC and Hyperband for
hyperparameter optimization. The code can be found on my gitlab
repo \footnote{\url{https://gitlab.com/fabian.g/deep-learning/tree/master}}.

\subsubsection*{Problem}

Unlike last exercise, the hyperparameter space now consists of real
hyperparameters (e.g. learning rate), discrete ones (e.g. number of
levels) and ``categorical'' ones (e.g. optimizing algorithm).

We use the Bayesian optimization framework SMAC which uses randfom
forest to model the objective function and Hyperband as a successive
halving interface.

\subsubsection*{Results}

\begin{figure}[h!]
  \centering
  \begin{subfigure}[b]{0.45\textwidth}
    \includegraphics[width=\textwidth]{./incumbent_performance_hb.png}
    \caption{Hyperband}
    \label{fig:inc_hb}
  \end{subfigure}
  \centering
  \begin{subfigure}[b]{0.45\textwidth}
    \includegraphics[width=\textwidth]{./incumbent_performance_smac.png}
    \caption{SMAC}
    \label{fig:inc_smac}
  \end{subfigure}
  \caption{Validation error of the incumbent by wall-clock time.}
\label{fig1}
\end{figure}

\ref{fig1} compares the performance of the incumbent configurations of
SMAC and Hyperband. Both reach an error of about 2 percent, Hyperband
after about 7000 s, SMAC after about 15000 s. The final error of
Hyperband is slighly lower than that of SMAC. The graphs of Hyperband
typically looked ``smoother''.

\subsubsection*{Evaluated learning curves}

\begin{figure}[h!]
  \centering
  \begin{subfigure}{0.45\textwidth}
    \includegraphics[width=\textwidth]{./lcs_hyperband.png}
    \caption{Hyperband}
    \label{fig:inc_hb}
  \end{subfigure}
  \centering
  \begin{subfigure}{0.45\textwidth}
    \includegraphics[width=\textwidth]{./lcs_smac.png}
    \caption{SMAC}
    \label{fig:inc_smac}
  \end{subfigure}
  \caption{Learning curves evaluated by the algorithms.}
\label{fig2}
\end{figure}

\ref{fig2} shows the learning curves SMAC and Hyperband evaluated. We
see that unlike SMAC, Hyperband often aborts bad configurations. Only
those in the last budget/number-tradeoff iterations, Hyperband assigns
significant computation time to random configurations.

On the other hand, we see that SMAC typically has curves with better
starting values. This reflects the fact that during its minimum
search, SMAC uses its knowledge about past configurations and does not
start off with random configurations.

\end{document}
